local mod = RW:Boss("Valithra Dramwalker", "Icecrown Citadel", "Icecrown Citadel", "Frostwing Hall")
local L

mod.BossIcon = [[Interface\Icons\achievement_boss_shadeoferanikus]]
mod.SubCatIcon = [[Interface\Icons\achievement_dungeon_icecrown_frostwinghalls]]

------------------------------------
-- Variables

-- Mana Void
local wManaVoid

-- Lay Waste
local wLayWaste, iLayWaste

-----------------------------------
-- Init
function mod:OnRegister()
	L = mod:RegisterLocale("enUS")
	if L then
		L.name = "Valithra Dramwalker"
		L.info = "Experimental mod still, timers and warnings may be invalid or off."
		L.pull = "Heroes, lend me your aid! I... I cannot hold them off much longer. You must heal my wounds!"
		L.win = "I am renewed! Ysera grant me the favour to lay these foul creatures to rest!"
		
		L.show_health = "Show health bar for Valithra Dramwalker"
	end
	L = mod:GetLocale()
	mod.L = L
	
	mod:SetTrigger(L.pull, 36789, 37868, 36791, 37863, 37934, 37886, 37950, 37985)
	mod:SetWin(L.win)
	
	self:AddBoolOption("BossHealthbar", L.show_health, nl, true, select(3, GetSpellInfo(71189)))
	
	-- Mana Void
	wManaVoid		= self:RunawayWarning(71179)
	
	-- Lay Waste
	wLayWaste		= self:RunawayWarning(69326)
	iLayWaste		= self:Icon("SKULL", 69326, false, 12, "CROSS")
end

-----------------------------------------
-- Locals

-----------------------------------------
-- Start

function mod:OnEngage(trigger)
	self:Track("ManaVoid", 71179, 71741, 71086, 71743, 72029, 72030, 71085) -- 71085 may be the spell cast before they are summoned
	self:Track("LayWaste", 69325, 71730, 69326, 71737, 72027, 72028) -- 69325 and 71730 are channeled spells while the rest ar instant spells.

	if self.db.profile.BossHealthbar then
		self:SendMessage("RW_AddHealthFrame", 36789)
	end
end

function mod:ManaVoid(event, args)
	if event == "SPELL_AURA_APPLIED" then
		if args:IsPlayer() then
			wManaVoid:Show()
		end
	end
end

function mod:LayWaste(event, args)
	if event == "SPELL_AURA_APPLIED" then
		if args:IsPlayer() then
			wLayWaste:Show()
		end
		iLayWaste:Show(args.dName)
	end
end